SystemOrganization addCategory: #'MC2-Tests-Core'!

Object subclass: #MDTestBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:43'!
definition
	^ MDDefinitionVariant forElement: self element! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
definition: aSymbol
	| definition |
	definition := MDDefinitionVariant forElement: (self element: aSymbol).
	definition properties at: #one put: 1.
	^ definition! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element
	^ self element: #Alpha! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element: aSymbol
	^ MDFakeElement named: aSymbol! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
elements
	^ Set
		with: (MDFakeElement named: #Alpha)
		with: (MDFakeElement named: #Beta)! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:26'!
memo
	^ self memo: #abc! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:28'!
memo: aSymbol
	^ MDMemo
		snapshot: self snapshot
		slice: self slice
		parents: Set new
		properties: (MDPropertyDictionary new id: aSymbol; yourself)! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 9/4/2009 16:42'!
merge
	^ self mergeIn: MDEnvironment forTesting! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 12/16/2007 22:41'!
mergeIn: wc
	
	wc loadVersion: (self versionWith: 'alpha').
	^ MDMerge
		toInclude: (self versionWith: 'beta')
		in: wc.! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal
	^ MDRemovalVariant forElement: self element! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal: aSymbol
	^ MDRemovalVariant forElement: (self element: aSymbol)! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 1/19/2007 23:12'!
slice
	^ MDExplicitSlice named: 'TestSlice'.! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'jf 10/21/2009 16:43'!
sliceVariant
	| slice variant environment domain |
	environment := MDEnvironment forTesting.
	domain := environment addDomain: (MDMonticelloDomain on: environment).
	slice := environment addSlice: self slice.
	variant := MDDefinitionVariant forElement: slice asElement.
	domain updateVariant: variant.
	^ variant! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 7/23/2008 07:14'!
sliceVersion
	^ MDElementVersion variant: self sliceVariant! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:09'!
snapshot
	^ self snapshot: [:versions | ].
! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 7/23/2008 07:10'!
snapshot: aBlock
	| versions |
	versions := Set new.	
	versions 
		add: (self versionFor: #Alpha with: 'alpha');
		add: (self versionFor: #Beta with: 'beta')	.
	aBlock value: versions.
	^ MDSnapshot withVersions: versions! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:12'!
updateVersion: anElementVersion property: aSymbol put: anObject 
	| newVariant |
	newVariant := anElementVersion variant copy.
	newVariant properties at: aSymbol put: anObject.
	^MDElementVersion 
		variant: newVariant
		ancestry: anElementVersion fullAncestry! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:39'!
version
	^ MDElementVersion variant: self definition! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 3/25/2005 22:55'!
versionFor: elementName
	^ self versionFor: elementName with: elementName asLowercase! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
versionFor: elementName with: value
	| element snapshot |
	element := MDFakeElement named: elementName.
	snapshot := MDDefinitionVariant forElement: element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

!MDTestBuilder methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
versionWith: value
	| snapshot |
	snapshot := MDDefinitionVariant forElement: self element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

TestCase subclass: #MDAdaptionTest
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDAdaptionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 22:33'!
isAbstract
	^ self name = #MDAdaptionTest! !

!MDAdaptionTest methodsFor: 'constants' stamp: 'cwp 9/12/2009 22:29'!
adaptorSelectors
	^ #(isPresent isUpToDate: load: remove update: merge:into:onFailure:)! !

!MDAdaptionTest methodsFor: 'configuration' stamp: 'jf 10/21/2009 16:19'!
domainClass
	self subclassResponsibility! !

!MDAdaptionTest methodsFor: 'running' stamp: 'jf 10/21/2009 16:19'!
setUp
	domain := self domainClass new! !

!MDAdaptionTest methodsFor: 'constructing' stamp: 'cwp 3/15/2005 22:22'!
slice
	^ MDExplicitSlice named: 'Foo'! !

!MDAdaptionTest methodsFor: 'running' stamp: 'jf 10/21/2009 16:11'!
tryAdapting: anElement 
	| adaptor |
	adaptor := domain adapt: anElement.
	self adaptorSelectors do: [ :ea | self assert: (adaptor respondsTo: ea) ]! !

TestCase subclass: #MDAdaptorTest
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 11:53'!
isAbstract
	^ self name = #MDAdaptorTest! !

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2005 21:40'!
shouldInheritSelectors
	^ true! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:43'!
adaptor
	^ self adaptorForElement: self element! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/2/2006 18:05'!
adaptorClass
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 12/1/2005 22:17'!
adaptorForElement: anElement
	^ self adaptorClass forElement: anElement inSystem: self system! !

!MDAdaptorTest methodsFor: 'asserting' stamp: 'jf 10/16/2009 22:30'!
assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:49'!
bogusClass
	^ MDBogusA! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 9/6/2009 14:56'!
canBeOutOfDate
	^ true! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 3/23/2005 00:03'!
canBeUnloadable
	^ true! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 10/16/2009 16:20'!
createObject
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 3/2/2006 18:12'!
displayString
	^ self properties asString! !

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 2/1/2006 21:20'!
editDuring: aBlock
	aBlock value.
	system commit.! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 11/17/2007 01:25'!
initials
	^ self stamp copyUpTo: $ ! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'jf 10/16/2009 22:32'!
properties
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 5/22/2008 00:13'!
setUp
	system := MDPlatform current systemEditor! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 12/3/2005 23:00'!
system
	^ system! !

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 2/5/2005 20:53'!
tearDown
	self destroyObject! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 14:45'!
testIsLoadable
	self assert: (self adaptor isLoadable: self properties)
! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:42'!
testIsPresent
	self createObject.
	self assert: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 10/16/2009 23:24'!
testIsUnloadable
	| adaptor |
	self canBeUnloadable ifTrue: 
		[ adaptor := self adaptorForElement: self unloadableElement.
		self deny: (adaptor isLoadable: self unloadableProperties) ]! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 00:10'!
testIsUpToDate
	self createObject.
	self assert: (self adaptor isUpToDate: self properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 10/16/2009 21:41'!
testLoad
	self editDuring: [self adaptor load: self properties].
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 21:07'!
testNotPresent
	self deny: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'jf 9/6/2009 15:04'!
testNotUpToDate
	| properties |
	self canBeOutOfDate ifTrue: [
		self propertyToChange ifNil: [^ self].
		self createObject.
		properties := self properties.
		properties at: self propertyToChange put: self changedValue.
		self deny: (self adaptor isUpToDate: properties) ]! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/3/2005 23:14'!
testRemove
	self createObject.
	self editDuring: [self adaptor remove].
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/3/2005 23:16'!
testRemoveNotPresent
	self editDuring: [self adaptor remove].
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 13:23'!
testUnloadableNotPresent
	| adaptor |
	self canBeUnloadable ifTrue: 
		[ adaptor := self adaptorForElement: self unloadableElement.
		self deny: adaptor isPresent ]! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/11/2005 10:43'!
testUpdate
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self editDuring: [self adaptor update: properties].
	self assert: properties = self properties! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/3/2005 23:17'!
testUpdateSideEffects
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self editDuring: [self adaptor update: properties].
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 4/9/2005 01:54'!
timeStamp
	^ MDTimestamp fromSqueakMethodStamp: self stamp! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 10/17/2009 00:40'!
unloadableElement
	"Returns an element that, combined with #unloadableProperties,
	cannot be loaded."
	
	^ self element! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'jf 10/17/2009 00:40'!
unloadableProperties
	"Returns properties that, when applied to #unloadableElement, result in the
	element being unloadable."
	
	^ self properties! !

TestCase subclass: #MDAnnouncementTest
	instanceVariableNames: 'element project slice received environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDAnnouncementTest methodsFor: 'accessing' stamp: 'cwp 8/18/2009 03:00'!
environment
	^ environment! !

!MDAnnouncementTest methodsFor: 'running' stamp: 'cwp 11/11/2009 23:43'!
setUp
	element := MDFakeElement named: #Alpha.
	environment := MDEnvironment forTesting.
	project := MDProject forTesting.
	environment addProject: project.
	slice := environment addSlice: MDExplicitSlice forTesting.
	slice addElement: element.
	project addSlice: slice.
	environment subscribe.
	received := OrderedCollection new.! !

!MDAnnouncementTest methodsFor: 'running' stamp: 'jf 11/19/2009 16:59'!
subscribeTo: aClass 
	self environment announcer
		observe: aClass
		do: [ :ann | received add: ann ]! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/19/2009 16:58'!
testAdded
	self environment announce: (MDElementAdded for: element).
	self assert: (self environment isDirty: slice)! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'cwp 11/25/2009 15:09'!
testDirty
	self subscribeTo: MDSliceDirty.
	self environment announce: (MDElementAdded for: element).
	self deny: received isEmpty.
	self assert: received first slice = slice! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/19/2009 16:58'!
testModified
	self environment announce: (MDElementModified for: element).
	self assert: (self environment isDirty: slice)! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/25/2009 16:25'!
testProjectRemoved
	self subscribeTo: MDProjectRemoved.
	self environment removeProjectId: project id.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDProjectRemoved).
	self assert: received first environment = self environment.
	self assert: received first project = project.
	! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/25/2009 16:20'!
testProjectRenamed
	
	self subscribeTo: MDProjectRenamed.
	project name: 'someOtherProject'.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDProjectRenamed).
	self assert: received first project = project.
	! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/19/2009 16:58'!
testRemoved
	self environment announce: (MDElementRemoved for: element).
	self assert: (self environment isDirty: slice)! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/25/2009 16:24'!
testRepositoryAdded
	| repository |
	self subscribeTo: MDRepositoryAdded.
	repository := environment addRepository: (MDMemoryRepository named: 'anotherTest').
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDRepositoryAdded).
	self assert: received first environment = self environment.
	self assert: received first repository = repository! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/25/2009 16:24'!
testRepositoryAssociationAdded
	| repository |
	self subscribeTo: MDRepositoryAssociated.
	self subscribeTo: MDRepositoryAdded.
	repository := MDMemoryRepository named: 'anotherTest'.
	environment addRepository: repository toProject: project.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDRepositoryAdded).
	self assert: received first environment = self environment.
	self assert: received first repository = repository.
	self assert: (received second isKindOf: MDRepositoryAssociated).
	self assert: received second project = project.
	self assert: received second repository = repository! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/25/2009 16:25'!
testRepositoryAssociationRemoved
	
	| repository |
	repository := project addRepository: MDMemoryRepository forTesting.
	self subscribeTo: MDRepositoryDissociated.
	project removeRepository: repository.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDRepositoryDissociated).
	self assert: received first project = project.
	self assert: received first repository = repository! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/25/2009 16:28'!
testRepositoryRemoved
	
	| repository |
	repository := MDMemoryRepository forTesting.
	environment addRepository: repository.
	project addRepository: repository.
	self subscribeTo: MDRepositoryRemoved.
	self subscribeTo: MDRepositoryDissociated.
	environment removeRepositoryId: repository id.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDRepositoryDissociated).
	self assert: received first project = project.
	self assert: received first repository = repository.
	self assert: (received second isKindOf: MDRepositoryRemoved).
	self assert: received second environment = self environment.
	self assert: received second repository = repository.! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/25/2009 16:29'!
testSliceAdded
	| anotherSlice |
	self subscribeTo: MDSliceAdded.
	anotherSlice := environment addSlice: (MDExplicitSlice named: 'anotherTest').
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDSliceAdded).
	self assert: received first environment = self environment.
	self assert: received first slice = anotherSlice.! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/25/2009 16:30'!
testSliceAssociationAdded
	| anotherSlice |
	self subscribeTo: MDSliceAssociated.
	self subscribeTo: MDSliceAdded.
	anotherSlice := MDExplicitSlice named: 'anotherTest'.
	environment addSlice: anotherSlice toProject: project.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDSliceAdded).
	self assert: received first environment = self environment.
	self assert: received first slice = anotherSlice.
	self assert: (received second isKindOf: MDSliceAssociated).
	self assert: received second project = project.
	self assert: received second slice = anotherSlice.! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/25/2009 16:31'!
testSliceAssociationRemoved
	
	self subscribeTo: MDSliceDissociated.
	project removeSlice: slice.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDSliceDissociated).
	self assert: received first project = project.
	self assert: received first slice = slice.! !

!MDAnnouncementTest methodsFor: 'tests' stamp: 'jf 11/25/2009 16:32'!
testSliceRemoved
	
	self subscribeTo: MDSliceRemoved.
	self subscribeTo: MDSliceDissociated.
	environment removeSliceId: slice id.
	self deny: received isEmpty.
	self assert: (received first isKindOf: MDSliceDissociated).
	self assert: received first project = project.
	self assert: received first slice = slice.
	self assert: (received second isKindOf: MDSliceRemoved).
	self assert: received second environment = self environment.
	self assert: received second slice = slice.! !

TestCase subclass: #MDDefaultDomainTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDDefaultDomainTest methodsFor: 'asserting' stamp: 'cwp 6/15/2008 20:25'!
assertDefaultIdentityFor: aSymbol
	| first second |
	first := MDDomain defaultForType: aSymbol.
	second := MDDomain defaultForType: aSymbol.
	self assert: first == second! !

TestCase subclass: #MDEnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDEnvironmentTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 15:19'!
testAddProject
	| environment project |
	environment := MDEnvironment new.
	project := MDProject forTesting.
	environment addProject: project.
	self assert: (environment projects includes: project)! !

!MDEnvironmentTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:48'!
testAddRepository
	| environment repository |
	environment := MDEnvironment new.
	repository := environment addRepository: MDMemoryRepository forTesting.
	self assert: (environment repositories includes: repository)! !

!MDEnvironmentTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:34'!
testAddSlice
	| environment slice slice2 |
	environment := MDEnvironment new.
	slice := MDExplicitSlice forTesting.
	slice2 := environment addSlice: slice.
	self assert: (environment slices includes: slice).
	self assert: slice == slice2! !

!MDEnvironmentTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2009 11:08'!
testDefault
	self assert: MDEnvironment default class == MDEnvironment! !

TestCase subclass: #MDHashstampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDHashstampTest methodsFor: 'support' stamp: 'cwp 8/8/2009 16:19'!
tag
	^ #(215 214 124 149 170 226 94 130 56 54 75 164 35 251 0 20 106 252 22) asByteArray.! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:27'!
testCheckByte
	| hashstamp |
	hashstamp := MDHashstamp 
		tag: #(215 214 124 149 170 226 94 130 56 54 75 164 35 251 0 20 106 252 22) asByteArray
		timestamp: (MDTimestamp fromInteger: 929031339).
	self assert: hashstamp checkByte = 251! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:04'!
testEqual
	| first second now |
	now := MDTimestamp now.
	first := MDHashstamp timestamp: now.
	second := MDHashstamp tag: first tag timestamp: now.
	self assert: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:11'!
testHash
	| first second now tag |
	now := MDTimestamp now.
	tag := self tag.
	first := MDHashstamp tag: tag timestamp: now.
	tag at: 1 put: 20.
	second := MDHashstamp tag: tag timestamp: now.
	self deny: first hash = second hash.
	self deny: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:31'!
testInvalid
	| hashstamp byte |
	hashstamp := MDHashstamp new.
	byte := hashstamp checkByte + 1.
	byte < 0 ifTrue: [byte := 255].
	byte > 255 ifTrue: [byte := 0].
	hashstamp at: 24 put: byte.
	self deny: hashstamp isValid! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLessThan
	| first second |
	first := MDHashstamp fromString: 'bjrm0RTKT7KesZu0C1N9d0Dv+-Fez-No'.
	second := MDHashstamp fromString: 'c0qD0lTwM3oFdWJn9yYiSxGZjuhr9NHe'.
	self assert: first <= second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:18'!
testNew
	| hashstamp |
	hashstamp := MDHashstamp new.
	self assert: hashstamp size = MDHashstamp hashstampSize.
	self assert: (MDTimestamp now asInteger - hashstamp timestamp asInteger) < 5.
	self assert: hashstamp tag size = 19.
	self assert: hashstamp checkByte < 255.
	self assert: hashstamp isValid.! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:27'!
testPrinting
	| hashstamp |
	hashstamp := MDHashstamp 
		tag: self tag
		timestamp: (MDTimestamp fromInteger: 929030771).
	self assert: hashstamp printString = 'BpzWQxTKT7KesZu0C1N9d0Dv+-Fez-Oq'! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:12'!
testRead
	| hashstamp |
	hashstamp := MDHashstamp new.
	self assert: hashstamp = (MDHashstamp fromString: hashstamp asString)
! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 16:16'!
testTag
	| hashstamp tag |
	tag := #(215 214 124 149 170 226 94 130 56 54 75 164 35 251 0 20 106 252 22) asByteArray.
	hashstamp := MDHashstamp 
		tag: tag
		timestamp: (MDTimestamp fromInteger: 929031339).
	self assert: hashstamp tag = tag.
	self deny: hashstamp tag == tag! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 8/8/2009 15:49'!
testTimestamp
	| first second now then |
	now := MDTimestamp now.
	then := MDTimestamp fromInteger: (now asInteger - 1).
	first := MDHashstamp timestamp: then.
	second := MDHashstamp timestamp: now.
	self deny: first timestamp = second timestamp.
	self deny: first = second! !

TestCase subclass: #MDHistorianTest
	instanceVariableNames: 'historian slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 3/6/2008 20:09'!
createMemo
	^ MDMemo
		snapshot: (MDSnapshot withVersions: Array new) 
		slice: slice
		parents: Array new
		properties: MDPropertyDictionary new.! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
markDirty
	| element |
	element := MDFakeElement named: #a.
	slice addElement: element.
	historian noteElementChanged: element.
! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 3/6/2008 18:45'!
memo
	^ self memoWithComment: 'This is a test'! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 3/8/2008 14:02'!
memoWithComment: aString
	^ [historian memo]
		on: MDCommentRequest
		do: [:req | req resume: aString]! !

!MDHistorianTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
setUp
	slice := MDExplicitSlice named: 'test'.
	historian := MDHistorian forSlice: slice.
! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testCancelCommentRequest
	| memo |
	memo := self memoWithComment: nil.
	self assert: memo isNil! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testComment
	| memo |
	memo := self memoWithComment: 'test123'.
	self assert: (memo properties comment = 'test123')! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 3/9/2008 22:25'!
testDirty
	
	self markDirty.
	self assert: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testEmptyComment
	| memo |
	memo := self memoWithComment: ''.
	self deny: (memo properties includesKey: #comment)! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testIncludeUpdatesOrdinal
	
	| child first second |
	first := self createMemo.
	second := self createMemo.
	second properties ordinal: 5.
	historian noteLoad: first.
	historian noteInclude: second.
	child := self memo.
	self assert: child properties ordinal = 6! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoad
	
	| parent child |
	parent := self createMemo.
	historian noteLoad: parent.
	child := self memo.
	self assert: child parents size = 1.
	self assert: child parents anyOne = parent hashstamp! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadAndInclude
	
	| child first second |
	first := self createMemo.
	second := self createMemo.
	historian noteLoad: first.
	historian noteInclude: second.
	child := self memo.
	self assert: child parents size = 2.
	self assert: child parents first = first hashstamp.
	self assert: child parents second = second hashstamp.! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadAndSave
	
	| child first second |
	first := self createMemo.
	second := self createMemo.
	historian noteLoad: first.
	historian noteSave: second.
	child := self memo.
	self assert: child parents size = 1.
	self assert: child parents anyOne = second hashstamp.
! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadClearsDirtyFlag
	
	| parent |
	self markDirty.
	parent := self createMemo.
	historian noteLoad: parent.
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testLoadUpdatesOrdinal
	
	| parent child |
	parent := self createMemo.
	parent properties ordinal: 5.
	historian noteLoad: parent.
	child := self memo.
	self assert: child properties ordinal = 6! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 3/6/2008 19:23'!
testNoParents
	
	self assert: self memo parents isEmpty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testNotDirty
	| element |
	element := MDFakeElement named: #a.
	historian noteElementChanged: element.
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testOrdinalsIncreaseByOne
	| memo |
	self memo.
	memo := self memo.
	self assert: memo properties ordinal = 2! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 12/28/2007 23:56'!
testOrdinalsStartAtOne

	self assert: self memo properties ordinal = 1! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testPlatformProperties
	| properties memo |
	properties := MDPropertyDictionary new.
	MDPlatform current updateMemoProperties: properties.
	
	memo := self memo.
	properties keysAndValuesDo:
		[:k :v | self assert: (memo properties at: k) = v]! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSave
	
	| parent child |
	parent := self memo.
	parent setSnapshot: (MDSnapshot withVersions: Array new) slice: slice. 
	historian noteSave: parent.
	child := self memo.
	self assert: child parents size = 1.
	self assert: child parents anyOne = parent hashstamp! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSaveAndInclude
	
	| child first second |
	first := self memo.
	second := self createMemo.
	first setSnapshot: (MDSnapshot withVersions: Array new) slice: slice. 
	historian noteSave: first.
	historian noteInclude: second.
	child := self memo.
	self assert: child parents size = 2.
	self assert: child parents first = first hashstamp.
	self assert: child parents second = second hashstamp.! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSaveClearsDirtyFlag
	| parent |
	self markDirty.	
	parent := self memo.
	parent setSnapshot: (MDSnapshot withVersions: Array new) slice: slice. 
	historian noteSave: parent.
	
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 3/8/2008 21:16'!
testStartsClean
	self deny: historian isDirty! !

!MDHistorianTest methodsFor: 'tests' stamp: 'cwp 12/28/2007 23:57'!
testUpdate
	
	historian properties abc: 123.
	self assert: self memo properties abc = 123! !

TestCase subclass: #MDMaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDMaterializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/16/2008 22:04'!
isAbstract
	^ self name = #MDMaterializerTest! !

MDMaterializerTest subclass: #MDUtf8MaterializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:53'!
assert: aByteArray yields: expected
	| actual |
	actual := MDMaterializer materialize: aByteArray.
	self assert: actual = expected! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/23/2008 08:57'!
testAboriginal
	self
		assert: #(15 9 3 225 144 129 225 144 130 225 144 131)
		yields: MDPlatform current aboriginalAbc! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:36'!
testAscii
	self
		assert: #(15 9 3 97 98 99)
		yields: 'abc'! !

!MDUtf8MaterializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/17/2008 01:07'!
testLatin
	self
		assert: #(15 9 3 195 161 98 99)
		yields: 'bc'! !

TestCase subclass: #MDPropertyDictionaryTest
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
setUp
	properties := MDPropertyDictionary new.! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:32'!
testGetNil
	self assert: (properties at: #undefined) isNil! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:29'!
testImplicitGet
	properties at: #one put: 1.
	self assert: properties one = 1! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:28'!
testImplicitPut
	properties one: 1.
	self assert: (properties at: #one) = 1! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:30'!
testPutNil
	properties at: #undefined put: nil.
	self assert: properties isEmpty! !

TestCase subclass: #MDRegistryTest
	instanceVariableNames: 'registry slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
setUp
	registry := MDRegistry new.
	slice := MDExplicitSlice new.
! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testIncludesId
	registry register: slice.
	self assert: (registry includesId: slice id)! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testObjectWithIdSatsifies
	registry register: slice.
	self assert: (registry objectWithId: slice id satisfies: [:o | o == slice]) ! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testRegistration
	registry register: slice.
	self assert: (registry objectWithId: slice id) == slice ! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/9/2007 21:58'!
testRemoval
	registry register: slice.
	registry unregisterId: slice id.
	self assert: registry objects isEmpty! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:37'!
testRemoveId
	registry register: slice.
	registry unregisterId: slice id.
	self assert: registry objects isEmpty! !

!MDRegistryTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/19/2007 23:37'!
testUnregister
	registry register: slice.
	registry unregister: slice.
	self assert: registry objects isEmpty! !

TestCase subclass: #MDReplicatorTest
	instanceVariableNames: 'source dest replicator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:00'!
assertDestIncludesMemo: memo 
	| snapshot |
	self assert: (dest memos includes: memo).
	self assert: (dest allHashstamps includes: memo reference).
	snapshot := dest get: memo reference.
	self assert: (dest allHashstamps includesAllOf: snapshot contents)! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:57'!
buildSource: aSymbol 
	| versions builder snapshot memo properties |
	builder := MDTestBuilder new.
	versions := #(#alpha #beta #gamma ) collect: 
		[ :letter | 
		| v |
		v := builder 
			versionFor: letter
			with: letter.
		source put: v.
		v ].
	snapshot := MDSnapshot withVersions: versions.
	source put: snapshot.
	properties := MDPropertyDictionary new.
	properties tag: aSymbol.
	memo := MDMemo 
		parents: Set new
		properties: properties.
	memo 
		setSnapshot: snapshot
		slice: builder slice.
	source put: memo! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:56'!
setUp
	source := MDMemoryRepository new.
	dest := MDMemoryRepository new.
	replicator := MDReplicator 
		from: source
		to: dest.
	self buildSource: #one! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:52'!
testCopyAll
	replicator copyAll.
	self assert: (dest selectFrom: source allHashstamps) isEmpty! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 20:54'!
testCopyAllReferenced
	| version |
	version := MDTestBuilder new 
		versionFor: #zappa
		with: #fribbitz.
	source put: version.
	replicator copyAll.
	self deny: (dest includes: version)! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/10/2008 22:15'!
testCopyMemo
	| memo |
	memo := source memos anyOne.
	replicator copyMemo: memo.
	self assertDestIncludesMemo: memo! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:03'!
testReject
	| memo |
	self buildSource: #two.
	replicator reject: [:ea | ea properties tag = #two].
	self assert: dest memos size = 1.
	memo := dest memos anyOne.
	self assert: memo properties tag = #one.
	self assertDestIncludesMemo: memo! !

!MDReplicatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2008 21:02'!
testSelect
	| memo |
	self buildSource: #two.
	replicator select: [:ea | ea properties tag = #two].
	self assert: dest memos size = 1.
	memo := dest memos anyOne.
	self assert: memo properties tag = #two.
	self assertDestIncludesMemo: memo! !

TestCase subclass: #MDRepositoryTest
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

MDRepositoryTest subclass: #MDMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 02:39'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	^ anElementVersion == otherElementVersion! !

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'cwp 5/24/2008 13:07'!
newRepository
	^ MDMemoryRepository named: 'test'! !

!MDRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2005 00:46'!
isAbstract
	^ self name = #MDRepositoryTest! !

!MDRepositoryTest methodsFor: 'asserting' stamp: 'cwp 11/8/2009 21:47'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	self assert: (MDSerializer serialize: anElementVersion) = (MDSerializer serialize: otherElementVersion)! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
memo
	| memo |
	memo := MDMemo new.
	memo setSnapshot: self snapshot slice: self slice.
	^ memo! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:45'!
newRepository
	self subclassResponsibility! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 12/23/2007 00:09'!
secondRepository
	^ self newRepository! !

!MDRepositoryTest methodsFor: 'running' stamp: 'cwp 5/22/2008 00:10'!
setUp
	repository := self newRepository! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:31'!
slice
	^ MDExplicitSlice named: 'Test Slice'! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 3/23/2005 22:53'!
snapshot
	^ MDSnapshot withVersions: (Set with: self version)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testGetUnknownVersion
	| snapshot |
	snapshot := self snapshot.
	self assert: (repository get: snapshot hashstamp) isNil! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/24/2008 13:06'!
testId
	self assert: (repository id isKindOf: MDHashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMemos
	| memo memos |
	
	memo := self memo.
	repository put: memo.
	
	memos :=  repository memos.
	
	self assert: memos size = 1.
	self assert: (memos anyOne = memo).
! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testPush
	| other version |
	other := self secondRepository.
	version := self version.
	repository put: version.
	repository pushTo: other.
	self assert: (other includes: version hashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testStoreSnapshot
	| snapshot |
	snapshot := self snapshot.
	repository put: snapshot.
	self assert: (repository get: snapshot hashstamp) isEquivalentTo: snapshot! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testStoreVersion
	| version |
	version := self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSynchronizeWith
	| versionOne versionTwo other |
	versionOne := self version.
	repository put: versionOne.
	
	other := self secondRepository.
	versionTwo := self version.
	other put: versionTwo.
	
	repository synchronizeWith: other.
	
	self assert: (repository includes: versionTwo hashstamp).
	self assert: (other includes: versionOne hashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 5/24/2008 13:06'!
testTimestamp
	self assert: (repository id timestamp isKindOf: MDTimestamp)! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'dc 6/21/2007 18:31'!
version
	^ (MDFakeElement named: #Alpha) newElementVersion! !

TestCase subclass: #MDSerializationBytesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSerializationBytesTest methodsFor: 'asserting' stamp: 'cwp 11/15/2008 12:59'!
assert: anObject serializesTo: anArray 
	| expected actual |
	actual := MDSerializer serialize: anObject.
	expected := anArray asByteArray.
	self assert: actual = expected! !

!MDSerializationBytesTest methodsFor: 'running' stamp: 'cwp 11/15/2008 13:00'!
setUp
	super setUp.
	MDMaterializer initializeTypes! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 18:50'!
testArray
	self 
		assert: #(1 2 3 )
		serializesTo: #(17 9 3 9 1 9 2 9 3)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 18:50'!
testBytesObject
	self 
		assert: #(1 2 3 ) asByteArray
		serializesTo: #(1 4 14 9 9 66 121 116 101 65 114 114 97 121 9 0 9 3 1 2 3)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 21:41'!
testClass
	self 
		assert: self class
		serializesTo: #(2 14 9 24 77 68 83 101 114 105 97 108 
					105 122 97 116 105 111 110 66 121 116 
					101 115 84 101 115 116 9 1 15 9 12 116 
					101 115 116 83 101 108 101 99 116 111 114)
		! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 18:50'!
testClassCommentElement
	self 
		assert: (MDClassCommentElement className: #MDBogusA)
		serializesTo: #(1 5 9 10 14 9 8 77 68 66 111 103 117 115 65)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 18:50'!
testClassElement
	self 
		assert: (MDClassElement className: #MDBogusA)
		serializesTo: #(1 5 9 9 14 9 8 77 68 66 111 103 117 115 65)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 18:51'!
testClassInstVarElement
	self 
		assert: (MDClassInstVarElement 
				className: #MDBogusA
				name: 'beth')
		serializesTo: #(1 5 9 13 14 9 8 77 68 66 111 103 117 115 65 15 9 4 98 101 116 104)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 18:51'!
testClassMethodElement
	| element |
	element := MDMethodElement 
		className: #MDBogusA
		selector: #one
		classIsMeta: true.
	self 
		assert: element
		serializesTo: #(1 5 9 15 14 9 8 77 68 66 111 103 117 115 65 14 9 3 111 110 101 7)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 18:51'!
testClassVarElement
	self 
		assert: (MDClassVarElement className: #MDBogusA name: 'Alpha')
		serializesTo: #(1 5 9 12 14 9 8 77 68 66 111 103 117 115 65 15 9 5 65 108 112 104 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 18:52'!
testDictionary
	| dict |
	dict := Dictionary new
		at: #a put: 1;
		at: #b put: 2;
		yourself.
	self 
		assert: dict
		serializesTo: #(19 9 2 14 9 1 97 9 1 14 9 1 98 9 2)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 20:06'!
testElementDefinition
	| definition |
	definition := MDTestBuilder new definition.
 	self assert: definition serializesTo: #(1 5 9 2 1 5 9 8 14 9 5 65 108 112 104 97 20 9 0)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:02'!
testElementRemoval
| removal |
	removal := MDTestBuilder new removal.
	self assert: removal serializesTo: #(1 5 9 3 1 5 9 8 14 9 5 65 108 112 104 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:03'!
testFakeElement
| element |
	element := MDTestBuilder new element.
	self assert: element serializesTo: #(1 5 9 8 14 9 5 65 108 112 104 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:04'!
testFalse
	self assert: false serializesTo: #(8)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 8/9/2009 01:14'!
testHashstamp
	| hashstamp |
	hashstamp := MDHashstamp 
		tag: #(125 157 216 208 156 108 194 80 120 113 37 62 186 106 129 6 71 54 62) asByteArray
		timestamp: (MDTimestamp fromInteger: 905800829).
	self 
		assert: hashstamp 
		serializesTo: #(22 53 253 108 125 125 157 216 208 156 108 194 80 120 113 37 62 186 106 129 6 71 54 62 31)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 19:06'!
testInstVarElement
	| element |
	element := MDInstVarElement className: #MDBogusA name: 'one'.
	self assert: element serializesTo: #(1 5 9 11 14 9 8 77 68 66 111 103 117 115 65 15 9 3 111 110 101)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:07'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.

	self 
		assert: string 
		serializesTo: #(15 10 1 44 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 97 
					97 97 97 97 97 97 97 97 97 97 97 97 97 97)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 8/9/2009 01:24'!
testMemo
	| memo |
	memo := MDTestBuilder new memo.
	memo instVarAt: 1 put: (MDHashstamp fromString: 'BTpiEUqnmCG0M-vpGmAqClg7Epiwyh+k').
	memo instVarAt: 2 put: (MDHashstamp fromString: 'BTpifCLy1McVFvfIDx7ZkWv5YA5quh3d').
	memo instVarAt: 5 put: (MDHashstamp fromString: 'Bq-Yoy3kfy4i+GisbhjJr6tIIPB7lHFr').
	MDSerializer serialize: memo.
	self 
		assert: memo 
		serializesTo: #(23 5 9 7 22 53 253 110 66 13 179 200 228 130 96 30 245 75 35 54 59 27 9 67 91 
					188 250 208 48 22 53 253 110 172 229 254 13 138 33 71 186 212 63 210 101 194 46 
					199 144 193 246 234 209 105 18 9 0 20 9 2 14 9 2 105 100 14 9 3 97 98 99 14 9 9 
					115 108 105 99 101 78 97 109 101 15 9 9 84 101 115 116 83 108 105 99 101 22 55 96
					100 211 225 112 175 225 174 1 43 184 158 219 213 220 142 84 81 179 73 197 52 119)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 19:11'!
testMethodElement
	| element |
	element := MDMethodElement className: #MDBogusA selector: #one.
	self
		assert: element
		serializesTo: #(1 5 9 15 14 9 8 77 68 66 111 103 117 115 65 14 9 3 111 110 101 8)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:12'!
testMultiString
	| ws |
	ws := MDPlatform current wideString.
	self assert: ws serializesTo: #(16 9 3 0 97 0 98 0 99)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:13'!
testNegativeLargeInteger
	self
		assert: SmallInteger minVal - 1
		serializesTo: #(13 9 4 64 0 0 1)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:15'!
testNegativeOneByteInteger
	self
		assert: -3
		serializesTo: #(11 0 3)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:16'!
testNegativeTwoByteInteger
	self 
		assert: -300
		serializesTo: #(11 1 44)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:16'!
testNil
	self assert: nil serializesTo: #(6)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:17'!
testOneByteInteger
	self assert: 7 serializesTo: #(9 7)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:18'!
testPointersObject
	| object |
	object := MDPlatform current variablePointersObject.
	self 
		assert: object 
		serializesTo: #(1 3 14 9 14 65 99 116 105 111 110 83 
					101 113 117 101 110 99 101 9 0 9 2 14 9 
					1 97 14 9 1 98)! !

!MDSerializationBytesTest methodsFor: 'tests - smalltalk' stamp: 'cwp 11/12/2008 19:33'!
testPoolImportElement
| element |
	element := MDPoolImportElement 
		className: #MDBogusA
		name: #MDBogusPoolA.
	self
		assert: element
		serializesTo: #(1 5 9 14 14 9 8 77 68 66 111 103 117 115 
					65 14 9 12 77 68 66 111 103 117 115 80 111 
					111 108 65)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:34'!
testPositiveLargeInteger
	self
		assert: SmallInteger maxVal + 1
		serializesTo: #(12 9 4 64 0 0 0)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:37'!
testPropertyDictionary
	| properties |
	properties := MDPropertyDictionary new
		first: 1;
		second: 'two';
		yourself.

	self
		assert: properties
		serializesTo: #(20 9 2 14 9 5 102 105 114 115 116 9 1 
					14 9 6 115 101 99 111 110 100 15 9 3 116 
					119 111)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:38'!
testSet
	self
		assert: #(1 2 3) asSet
		serializesTo: #(18 9 3 9 1 9 2 9 3)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'jf 9/6/2009 13:44'!
testSliceElement
| element |
	element := MDSliceElement 
		id: (MDHashstamp fromString: 'Bq-ZYEPFlgGUuIsEFFkb-TDVFkUHkOWs').
	self
		assert: element
		serializesTo: #(1 5 9 1 22 55 96 101 145 6 209 198 196 160 233 78 16 69 28 39 5 243 225 71 8 19 193 168 184)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:47'!
testSnapshot
| contents snapshot |
	contents := #('BTploHISPGtEjxw7iNSRzI4sPrBSpkcx' 'BTploIM6Z+ffONzz9IfyCOaH7I8zZPk-') 
		collect: [:ea | MDHashstamp fromString: ea].
	snapshot := MDSnapshot new.
	snapshot instVarAt: 1 put: (MDTimestamp fromInteger: 905802042).
	snapshot instVarAt: 2 put: contents.

	self 
		assert: snapshot
		serializesTo: #(23 5 9 6 21 53 253 113 58 17 9 2 22 53 253 113 209 53 30 109 46 80 
					191 223 9 185 151 157 253 65 184 111 115 94 215 10 61 22 53 253 113 
					209 70 8 148 10 235 105 159 255 45 74 254 57 169 147 37 66 191 149 188 1)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:53'!
testString
	self
		assert: 'abc'
		serializesTo: #(15 9 3 97 98 99)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/17/2008 01:07'!
testStringWithAccent
	self
		assert: 'bc'
		serializesTo: #(15 9 3 195 161 98 99)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:54'!
testSymbol
	self assert: #one serializesTo: #(14 9 3 111 110 101)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:55'!
testThreeByteInteger
	| number |
	number := (2 raisedTo: 16) + 1.
	self
		assert: number
		serializesTo: #(12 9 3 1 0 1)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:58'!
testTimestamp
	| ts |
	ts := MDTimestamp fromInteger: 905803057.
	self assert: ts serializesTo: #(21 53 253 117 49)	! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 19:59'!
testTrue
	self assert: true serializesTo: #(7)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 20:00'!
testTwoByteInteger
	self assert: 355 serializesTo: #(10 1 99)! !

!MDSerializationBytesTest methodsFor: 'tests - core' stamp: 'cwp 11/12/2008 20:04'!
testVersion
	| version |
	version := MDTestBuilder new version.
	version instVarAt: 1 put: (MDTimestamp fromInteger: 905803456).
	self 
		assert: version
		serializesTo: #(23 5 9 5 21 53 253 118 192 1 5 9 2 1 5 9 8 14 9 
					5 65 108 112 104 97 20 9 0 18 9 0)! !

TestCase subclass: #MDSerializationClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSerializationClassTest commentStamp: 'cwp 4/19/2008 14:31' prior: 0!
This suite of tests ensures that well-known classes are serialized using these class ids:

	    -- core --
	 1  MDSliceElement
	 2  MDDefinitionVariant
	 3  MDRemovalVariant
	 4  MDNullVersion
	 5  MDElementVersion
	 6  MDSnapshot
	 7  MDMemo

	     -- testing --
	 8  MDFakeElement

	    -- smalltalk --
	 9  MDClassElement
	10  MDClassCommentElement
	11  MDInstVarElement
	12  MDClassVarElement
	13  MDClassInstVarElement
	14  MDMethodElement

!

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/8/2009 21:48'!
assert: anObject hasClassId: anInteger
	| bytes |
	bytes := MDSerializer serialize: anObject.
	self assert: (#(1 23) includes: bytes first).	"type object"
	self assert: bytes second = 5.					"well-known class"
	self assert: bytes third = 9.					"byte integer"
	self assert: bytes fourth = anInteger! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 11:16'!
test01SliceElement
	self 
		assert: MDSliceElement new
		hasClassId: 1! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'jf 11/8/2009 19:49'!
test02DefinitionVariant
	self 
		assert: MDDefinitionVariant forTesting
		hasClassId: 2! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'jf 11/8/2009 19:49'!
test03RemovalVariant
	self 
		assert: MDRemovalVariant forTesting
		hasClassId: 3! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:17'!
test04NullVersion
	self 
		assert: MDNullVersion new
		hasClassId: 4! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:23'!
test05ElementVersion
	self 
		assert: MDElementVersion new
		hasClassId: 5! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:23'!
test06Snapshot
	self 
		assert: MDSnapshot new
		hasClassId: 6! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:24'!
test07Memo
	self 
		assert: MDMemo new
		hasClassId: 7! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:25'!
test08FakeElement
	self 
		assert: MDFakeElement new
		hasClassId: 8! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:26'!
test09ClassElement
	self 
		assert: MDClassElement new
		hasClassId: 9! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:28'!
test10ClassCommentElement
	self 
		assert: MDClassCommentElement new
		hasClassId: 10! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:28'!
test11InstVarElement
	self 
		assert: MDInstVarElement new
		hasClassId: 11! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:28'!
test12ClassVarElement
	self 
		assert: MDClassVarElement new
		hasClassId: 12! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 14:29'!
test13ClassInstVarElement
	self 
		assert: MDClassInstVarElement new
		hasClassId: 13! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/30/2008 07:00'!
test14PoolImportElement
	self 
		assert: MDPoolImportElement new
		hasClassId: 14! !

!MDSerializationClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/30/2008 06:59'!
test15MethodElement
	self 
		assert: MDMethodElement new
		hasClassId: 15! !

TestCase subclass: #MDSerializationTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSerializationTypeTest commentStamp: 'cwp 4/19/2008 12:04' prior: 0!
Here's the type specifications that this class enforces:

     1  object
     2  class (fixed)
     3  class (pointers)
     4  class (bytes)
     5  class (well-known)
     6  nil
     7  true
     8  false
     9  8 bit unsigned integer
    10  small positive integer
    11  small negative integer
    12  large positive integer
    13  large negative integer
    14  symbol (utf-8)
    15  string (utf-8)
    16  string (utf-16be)
    17  array
    18  set
    19  dictionary
    20  properties
    21  timestamp
    22  hashstamp
    23  hashed object!

!MDSerializationTypeTest methodsFor: 'asserting' stamp: 'cwp 11/8/2009 21:49'!
assertObject: anObject hasType: anInteger
	| bytes |
	bytes := MDSerializer serialize: anObject.
	self assert: bytes first = anInteger! !

!MDSerializationTypeTest methodsFor: 'running' stamp: 'cwp 11/8/2009 21:49'!
setUp
	super setUp.
	MDMaterializer initializeTypes! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 3/2/2008 13:28'!
test01Object
	self assertObject: self hasType: 1! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 3/2/2008 13:28'!
test02FixedClass
	self assertObject: self class hasType: 2! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 3/2/2008 13:29'!
test03PointersClass
	self 
		assertObject: MDPlatform current variablePointersObject class
		hasType: 3! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 3/2/2008 13:30'!
test04BytesClass
	self 
		assertObject: ByteArray
		hasType: 4! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 12:01'!
test05WellKnownClass
	self 
		assertObject: MDElementVersion
		hasType: 5! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:14'!
test06Nil
	self assertObject: nil hasType: 6! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:14'!
test07True
	self assertObject: true hasType: 7! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:14'!
test08False
	self assertObject: false hasType: 8! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:14'!
test09ByteInteger
	self assertObject: 3 hasType: 9! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:14'!
test10SmallPostiveInteger
	self assertObject: 355 hasType: 10! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:13'!
test11SmallNegativeInteger
	self assertObject: -300 hasType: 11! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:13'!
test12LargePositiveInteger
	self assertObject: SmallInteger maxVal + 1 hasType: 12! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:21'!
test13LargeNegativeInteger
	self assertObject: SmallInteger minVal - 1 hasType: 13! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:13'!
test14Symbol
	self assertObject: #testSymbol hasType: 14! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:13'!
test15Utf8String
	self assertObject: 'abc' hasType: 15! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 6/23/2008 08:42'!
test16Utf16String
	self 
		assertObject: (MDPlatform current wideString) 
		hasType: 16! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:12'!
test17Array
	self
		assertObject: Array new
		hasType: 17! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:12'!
test18Set
	self
		assertObject: Set new
		hasType: 18! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:12'!
test19Dictionary
	self
		assertObject: Dictionary new
		hasType: 19! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test20Properties
	self
		assertObject: MDPropertyDictionary new
		hasType: 20! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test21Timestamp
	self
		assertObject: MDTimestamp now
		hasType: 21! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test22Hashstamp
	self
		assertObject: (MDHashstamp fromString: 'AbjG2m8xWqxTBPAOm0Sq4bCsci7JbfKX')
		hasType: 22! !

!MDSerializationTypeTest methodsFor: 'tests' stamp: 'cwp 4/19/2008 10:11'!
test23HashedObject
	self
		assertObject: (MDSnapshot withVersions: Set new)
		hasType: 23! !

TestCase subclass: #MDSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSerializerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/16/2008 22:06'!
isAbstract
	^ self name = #MDSerializerTest! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2008 23:49'!
assert: actual equals: expected
	| limit |
	limit := actual size min: expected size.
	1 to: limit do: [:index | self assert: (actual at: index) = (expected at: index)].
	self assert: actual size = expected size! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:19'!
assert: anObject yields: expected 
	| stream actual |
	stream := ByteArray new writeStream.
	self serialize: anObject on: stream.
	actual := stream contents.
	self 
		assert: actual
		equals: expected! !

!MDSerializerTest methodsFor: 'as yet unclassified' stamp: 'jf 11/8/2009 18:54'!
serialize: anObject on: aStream
	self subclassResponsibility! !

MDSerializerTest subclass: #MDUtf16SerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:19'!
serialize: anObject on: aStream
	| serializer |
	serializer := MDSerializer on: aStream.
	serializer serializeUtf16String: anObject.! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/23/2008 08:57'!
testAboriginal
	self 
		assert: MDPlatform current aboriginalAbc
		yields: #(16 9 3 20 1 20 2 20 3)! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 12:05'!
testAscii
	self 
		assert: 'abc' 
		yields: #(16 9 3 0 97 0 98 0 99)! !

!MDUtf16SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/17/2008 01:07'!
testLatin
	self 
		assert: 'bc' 
		yields: #(16 9 3 0 225 0 98 0 99)
	! !

MDSerializerTest subclass: #MDUtf8SerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/15/2008 12:20'!
serialize: anObject on: aStream
	| serializer |
	serializer := MDSerializer on: aStream.
	serializer serializeUtf8String: anObject.! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/23/2008 08:57'!
testAboriginal
	self 
		assert: MDPlatform current aboriginalAbc
		yields: #(15 9 3 225 144 129 225 144 130 225 144 131)! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 12:06'!
testAscii
	self assert: 'abc' yields: #(15 9 3 97 98 99)! !

!MDUtf8SerializerTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/17/2008 01:07'!
testLatin
	self assert: 'bc' yields: #(15 9 3 195 161 98 99)! !

TestCase subclass: #MDSliceTest
	instanceVariableNames: 'slice elements environment domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSliceTest commentStamp: 'cwp 8/29/2005 00:40' prior: 0!
This comment needs to be here, or #testComment won't pass.!

!MDSliceTest class methodsFor: 'testing' stamp: 'cwp 3/16/2005 01:05'!
isAbstract
	^ self name = #MDSliceTest! !

!MDSliceTest class methodsFor: 'testing' stamp: 'cwp 3/16/2005 01:05'!
shouldInheritSelectors
	^ true! !

!MDSliceTest methodsFor: 'asserting' stamp: 'dc 6/26/2007 21:48'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels as: aBlock 
	self assertAllOf: expectedLabels butNoneOf: forbiddenLabels enumeratedAs: aBlock.
	self assertAllOf: expectedLabels butNoneOf: forbiddenLabels includedAs: aBlock.! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 5/22/2008 00:10'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels enumeratedAs: aBlock 
	| expected forbidden |
	expected := expectedLabels collect: aBlock.
	forbidden := forbiddenLabels collect: aBlock.
	elements := slice elements.
	self assert: (elements includesAllOf: expected).
	self deny: (elements includesAnyOf: forbidden)! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 3/3/2006 11:28'!
assertAllOf: expectedLabels butNoneOf: forbiddenLabels includedAs: aBlock 
	| expected forbidden |
	expected := expectedLabels collect: aBlock.
	expected do: [:ea | self assert: (slice includes: ea)].

	forbidden := forbiddenLabels collect: aBlock.
	forbidden do: [:ea | self deny: (slice includes: ea)]! !

!MDSliceTest methodsFor: 'accessing' stamp: 'jf 10/21/2009 16:02'!
domain
	^ domain ifNil: [ domain := MDMonticelloDomain on: self environment ]! !

!MDSliceTest methodsFor: 'accessing' stamp: 'jf 10/21/2009 15:56'!
environment
	^ environment ifNil: [ environment := MDEnvironment forTesting ]! !

!MDSliceTest methodsFor: 'running' stamp: 'jf 10/21/2009 16:37'!
setUp
	slice := self environment addSlice: self createSlice! !

!MDSliceTest methodsFor: 'accessing' stamp: 'jf 10/21/2009 16:08'!
sliceProperties
	^ (slice asElement adaptedFor: self domain) properties! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:59'!
testId
	self assert: (slice id isKindOf: MDHashstamp)! !

MDSliceTest subclass: #MDSmalltalkSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

MDSmalltalkSliceTest subclass: #MDExplicitSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDExplicitSliceTest methodsFor: 'constucting' stamp: 'cwp 10/2/2008 20:24'!
createSlice
	^ (MDExplicitSlice named: 'TestSlice')
		addElement: (MDClassElement className: #MDBogusA);
		addElement: (MDClassElement className: #MDSliceTest);
		addElement: (MDClassCommentElement className: #MDBogusA);
		addElement: (MDClassCommentElement className: #MDSliceTest);
		addElement: (MDMethodElement 
				className: #MDSliceTest
				selector: #classes);
		addElement: (MDMethodElement 
				className: #MDSliceTest
				selector: #methods);
		addElement: (MDMethodElement 
				className: #MDSliceTest
				selector: #bogusMethodA
				classIsMeta: true);
		addElement: (MDMethodElement 
				className: #MDSliceTest
				selector: #bogusMethodB
				classIsMeta: true);
		addElement: (MDInstVarElement 
				className: #MDBogusA
				name: 'one');
		addElement: (MDClassVarElement 
				className: #MDBogusA
				name: 'MDAlpha');
		addElement: (MDClassInstVarElement 
				className: #MDBogusA
				name: 'aleph');
		addElement: (MDPoolImportElement 
				className: #MDBogusA
				name: 'MDBogusPoolA');
		addElement: (MDPoolImportElement 
				className: #MDBogusA
				name: 'TextConstants');
		yourself! !

!MDExplicitSliceTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:04'!
testProperties
	| properties |
	properties := self sliceProperties.
	self assert: properties name = 'TestSlice'.
	self assert: properties elements = slice elements! !

!MDSmalltalkSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 6/5/2008 07:21'!
isAbstract
	^ self name = #MDSmalltalkSliceTest! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:51'!
testClassInstVarClasses
	self 
		assertAllOf: #(MDBogusA)
		butNoneOf: #(MDNonexistentClass)
		as: [:name | MDClassInstVarElement 
								className: name 
								name: #aleph]. 
		
! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:03'!
testClassInstVars
	self 
		assertAllOf: #(aleph)
		butNoneOf: #(doesntexist)
		as: [:name | MDClassInstVarElement 
								className: #MDBogusA 
								name: name]. 
		
! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:54'!
testClassMethodClasses
	self 
		assertAllOf: #(MDSliceTest)
		butNoneOf: #(MDNonexistentClass)
		as: 
			[:name | 
			MDMethodElement 
				className: name
				selector: #bogusMethodA
				classIsMeta: true]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:03'!
testClassMethods
	self 
		assertAllOf: #(#bogusMethodA #bogusMethodB )
		butNoneOf: #(#methodDoesntExist )
		as: 
			[:sel | 
			MDMethodElement 
				className: #MDSliceTest
				selector: sel
				classIsMeta: true]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 10/2/2008 20:22'!
testClassVarClasses
	self 
		assertAllOf: #(MDBogusA)
		butNoneOf: #(MDNonexistentClass)
		as: [:name | MDClassVarElement className: name name: #MDAlpha]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 10/2/2008 20:22'!
testClassVars
	self 
		assertAllOf: #('MDAlpha' )
		butNoneOf: #('DoesntExist' )
		as: [:name | MDClassVarElement className: #MDBogusA name: name]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:41'!
testClasses
	self 
		assertAllOf: #(#MDBogusA #MDSliceTest )
		butNoneOf: #(#MDNonexistentClass)
		as: [:name | MDClassElement className: name]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:54'!
testComments
	self 
		assertAllOf: #(#MDSliceTest )
		butNoneOf: #(#MDNonexistentClass)
		as: [:name | MDClassCommentElement className: name]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:03'!
testIncludedComments
	self 
		assertAllOf: #(MDBogusA MDSliceTest)
		butNoneOf: #(Object)
		includedAs: [:name | MDClassCommentElement className: name]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:46'!
testInstVarClasses
	self 
		assertAllOf: #(MDBogusA)
		butNoneOf: #(MDNonexistentClass)
		as: [:name | MDInstVarElement className: name name: 'one']! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:03'!
testInstVars
	self 
		assertAllOf: #('one' )
		butNoneOf: #('doesntexist' )
		as: [:name | MDInstVarElement className: #MDBogusA name: name]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:56'!
testMethodClasses
	self 
		assertAllOf: #(MDSliceTest)
		butNoneOf: #(MDNonexistentClass)
		as: [:name | MDMethodElement className: name selector: #classes]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:03'!
testMethods
	self 
		assertAllOf: #(#classes #methods )
		butNoneOf: #(#methodDoesntExist )
		as: [:sel | MDMethodElement className: #MDSliceTest selector: sel]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/14/2008 12:57'!
testPoolImportClasses
	self 
		assertAllOf: #(MDBogusA)
		butNoneOf: #(MDNonexistentClass)
		as: 
			[ :name | 
			MDPoolImportElement 
				className: name
				name: #MDBogusPoolA ]! !

!MDSmalltalkSliceTest methodsFor: 'tests' stamp: 'cwp 6/1/2008 23:04'!
testPoolImports
	self 
		assertAllOf: #(#MDBogusPoolA #TextConstants )
		butNoneOf: #(#PoolDoesntExist )
		as: 
			[ :name | 
			MDPoolImportElement 
				className: #MDBogusA
				name: name ]! !

MDSmalltalkSliceTest subclass: #MDUnionSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2008 18:56'!
createSlice
	^ MDUnionSlice 
		name: 'TestSlice'
		slices: {  (self createSliceA). (self createSliceB)  }! !

!MDUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/3/2008 20:43'!
createSliceA
	^ (MDExplicitSlice named: 'TestSlice')
		addElement: (MDClassElement className: #MDBogusA);
		addElement: (MDClassElement className: #MDSliceTest);
		addElement: (MDClassCommentElement className: #MDBogusA);
		addElement: (MDClassCommentElement className: #MDSliceTest);
		addElement: (MDMethodElement className: #MDSliceTest selector: #classes);
		addElement: (MDMethodElement className: #MDSliceTest selector: #methods);
		addElement: (MDMethodElement 
						className: #MDSliceTest 
						selector: #bogusMethodA 
						classIsMeta: true);
		yourself! !

!MDUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:25'!
createSliceB
	^ (MDExplicitSlice named: 'TestSlice2')
		addElement: (MDMethodElement 
				className: #MDSliceTest
				selector: #bogusMethodB
				classIsMeta: true);
		addElement: (MDInstVarElement 
				className: #MDBogusA
				name: 'one');
		addElement: (MDClassVarElement 
				className: #MDBogusA
				name: 'MDAlpha');
		addElement: (MDClassInstVarElement 
				className: #MDBogusA
				name: 'aleph');
		addElement: (MDPoolImportElement 
				className: #MDBogusA
				name: 'MDBogusPoolA');
		addElement: (MDPoolImportElement 
				className: #MDBogusA
				name: 'TextConstants');
		yourself! !

!MDUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/14/2008 16:55'!
testIntersectingSlices
	| a b |
	a := (MDExplicitSlice named: 'A')
		addElement: (MDFakeElement named: #x);
		yourself.
	b := (MDExplicitSlice named: 'B')
		addElement: (MDFakeElement named: #x);
		yourself.
	slice := MDUnionSlice 
		name: 'Intersection'
		slices: {  a. b  }.
	elements := Array streamContents: [ :stream | slice elementsDo: [ :ea | stream nextPut: ea ] ].
	self assert: elements size = 1.
	self assert: elements first name = #x! !

!MDUnionSliceTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:05'!
testProperties
	| properties |
	properties := self sliceProperties.
	self assert: properties sliceIds isCollection! !

TestCase subclass: #MDStElementDisplayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:53'!
testClass
	| element string |
	element := MDClassElement className: #MDBogusA.
	string := element printString.
	self assert: string = 'MDBogusA'! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:54'!
testClassComment
	| element string |
	element := MDClassCommentElement className: #MDBogusA.
	string := element printString.
	self assert: string = 'MDBogusA comment'! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:47'!
testClassInstVar
	| element string |
	element := MDClassInstVarElement 
		className: #MDBogusA
		name: 'one'.
	string := element printString.
	self assert: string = 'MDBogusA: class instance variable ''one'''! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 22:00'!
testClassMethod
	| element string |
	element := MDMethodElement className: #MDBogusA selector: #one classIsMeta: true.
	string := element printString.
	self assert: string = 'MDBogusA class>>one'! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:44'!
testClassVar
	| element string |
	element := MDClassVarElement 
		className: #MDBogusA
		name: 'MDAlpha'.
	string := element printString.
	self assert: string = 'MDBogusA: class variable ''MDAlpha'''! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:46'!
testInstVar
	| element string |
	element := MDInstVarElement 
		className: #MDBogusA
		name: 'one'.
	string := element printString.
	self assert: string = 'MDBogusA: instance variable ''one'''! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:56'!
testMethod
	| element string |
	element := MDMethodElement className: #MDBogusA selector: #one.
	string := element printString.
	self assert: string = 'MDBogusA>>one'! !

!MDStElementDisplayTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2008 21:49'!
testPoolImport
	| element string |
	element := MDPoolImportElement
		className: #MDBogusA
		name: 'one'.
	string := element printString.
	self assert: string = 'MDBogusA: pool import ''one'''! !

TestCase subclass: #MDTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

MDTestCase subclass: #MDAncestryTest
	instanceVariableNames: 'parent child'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 3/2/2005 23:15'!
null
	^ MDNullVersion forElement: self element! !

!MDAncestryTest methodsFor: 'running' stamp: 'cwp 3/2/2005 22:46'!
setUp
	parent := self version.
	child := self 
				updateVersion: parent
				property: #foo
				put: 'alpha2'! !

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:55'!
sibling
	^self 
		updateVersion: parent
		property: #bar
		put: 'bar'! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildConflictsWithParent
	self deny: (child conflictsWith: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testChildConflictsWithSibling
	self assert: (child conflictsWith: self sibling)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildPrecedesParent
	self deny: (child precedes: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:17'!
testChildPreceedsNull
	self deny: (child precedes: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testChildSucceedsNull
	self assert: (child succeeds: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildSucceedsParent
	self assert: (child succeeds: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:18'!
testChildSuccessorNull
	self assert: (child successor: self null onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:19'!
testChildSuccessorParent
	self assert: (child successor: parent onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:07'!
testChildSuccessorSibling
	| result merged sibling |
	sibling := self sibling.
	merged := child successor: sibling
				onConflict: 
					[result := self definition.
					result properties at: #merged put: true.
					result].
	self assert: (merged succeeds: child).
	self assert: (merged succeeds: sibling).
	self assert: merged variant properties merged! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testNullPrecedesChild
	self assert: (self null precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testNullSucceedsChild
	self deny: (self null succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:18'!
testNullSuccessorChild
	self assert: (child successor: self null onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:46'!
testParentConflictsWithChild
	self deny: (parent conflictsWith: child).! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentPrecedesChild
	self assert: (parent precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentSucceedsChild
	self deny: (parent succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:19'!
testParentSuccessorChild
	self assert: (parent successor: child onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:15'!
testSiblingConflictsWithChild
	self assert: (self sibling conflictsWith: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:59'!
testSiblingPreceedsChild
	self deny: (self sibling precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 00:00'!
testSiblingSucceedsChild
	self deny: (self sibling succeeds: child)! !

MDTestCase subclass: #MDDomainTest
	instanceVariableNames: 'environment domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

MDDomainTest subclass: #MDChangeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 14:23'!
testAddition
	| change element |
	element := self element.
	self atProperty: #one put: 'beta'.
	change := environment workspace changeForElement: element do: [:v | v].
	self assert: (change version isKindOf: MDNullVersion).
	self assert: change variant element = element.
	self assert: change variant properties one = 'beta'! !

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 14:23'!
testModification
	| version change |
	version := self versionWith: 'alpha'.
	environment workspace loadVersion: version.
	self atProperty: #one put: 'beta'.
	change := environment workspace changeForElement: version element do: [:v | v].
	self assert: change version = version.
	self assert: change variant element = version element.
	self assert: change variant properties one = 'beta'! !

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/4/2009 14:22'!
testNoChange
	| version change |
	version := self versionWith: 'alpha'.
	environment workspace loadVersion: version.
	change := environment workspace changeForElement: version element do: [:v | self fail].
	self assert: change isNil! !

!MDChangeTest methodsFor: 'as yet unclassified' stamp: 'jf 10/21/2009 16:13'!
testRemoval
	| version change |
	version := self versionWith: 'alpha'.
	environment workspace loadVersion: version.
	domain removeElement: version element.
	change := environment workspace 
		changeForElement: version element
		do: [ :v | v ].
	self assert: change version = version.
	self assert: change variant isRemoval! !

MDDomainTest subclass: #MDDomainOpsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testCurrentDefinition
	| variant |
	self 
		atElement: self element
		property: #one
		put: 1.
	variant := self definition.
	domain updateVariant: variant.
	self assert: (variant properties at: #one) = 1! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testIsLoadable
	| variant |
	variant := self definition.
	variant properties 
		at: #one
		put: 1.
	self assert: (domain isLoadable: variant)! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testLoadAndUpdate
	| original retrieved |
	original := self definition.
	original properties
		at: #one
			put: 1;
		at: #two
			put: 2;
		at: #three
			put: 3.
	domain loadVariant: original.
	retrieved := domain updateVariant: self definition.
	self assert: original properties = retrieved properties! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testLoadAndUpdateRemoval
	| original retrieved |
	original := self definition.
	original properties
		at: #one
			put: 1;
		at: #two
			put: 2;
		at: #three
			put: 3.
	domain loadVariant: original.
	retrieved := domain updateVariant: self removal.
	self assert: retrieved properties = original properties! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testLoadDefinition
	| variant |
	variant := self definition.
	variant properties
		at: #one
			put: 1;
		at: #two
			put: 2;
		at: #three
			put: 3.
	domain loadVariant: variant.
	self assert: (self 
			atElement: self element
			property: #one) = 1.
	self assert: (self 
			atElement: self element
			property: #two) = 2.
	self assert: (self 
			atElement: self element
			property: #three) = 3! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testLoadRemoveAndUpdate
	| original retrieved |
	original := self definition.
	original properties
		at: #one
			put: 1;
		at: #two
			put: 2;
		at: #three
			put: 3.
	domain loadVariant: original.
	domain loadVariant: self removal.
	retrieved := domain updateVariant: self definition.
	self assert: retrieved element = self element.
	self assert: retrieved isRemoval! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testNotLoadable
	| variant |
	variant := self definition: #'Alpha/Delta'.
	variant properties 
		at: #one
		put: 1.
	self deny: (domain isLoadable: variant)! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testRemoval
	| variant |
	self 
		atElement: self element
		property: #one
		put: '1'.
	variant := self removal.
	domain loadVariant: variant.
	self assert: (self 
			atElement: self element
			property: #one) isNil! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testRemovalLoadable
	| variant |
	variant := self removal: #'Alpha/Delta'.
	self assert: (domain isLoadable: variant)! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testRemovalUpToDate
	| variant removal |
	variant := self definition.
	removal := self removal.
	variant properties one: '1'.
	domain loadVariant: variant.
	self deny: (domain isUpToDate: removal).
	domain loadVariant: removal.
	self assert: (domain isUpToDate: removal)! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testTransaction
	| variant |
	variant := self definition.
	variant properties 
		at: #one
		put: 1.
	domain transaction: [ domain loadVariant: variant ].
	self assert: (self 
			atElement: self element
			property: #one) = 1! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testUpToDate
	| variant |
	variant := self definition.
	variant properties source: 'one ^ 1'.
	domain loadVariant: variant.
	self assert: (domain isUpToDate: variant).
	self 
		atElement: self element
		property: #source
		put: 'one ^ 11'.
	self deny: (domain isUpToDate: variant)! !

!MDDomainOpsTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testUpdateDoesntChangeElement
	| variant original |
	variant := self definition.
	original := variant element.
	domain updateVariant: variant.
	self assert: variant element = original! !

!MDDomainTest class methodsFor: 'testing' stamp: 'jf 10/21/2009 16:14'!
isAbstract
	^ self name = #MDDomainTest! !

!MDDomainTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:37'!
assertElement: elem property: prop hasValue: value
	self assert: (self atElement: (self element: elem) property: prop) = value! !

!MDDomainTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:52'!
assertElementHasDefaultValue: aSymbol
	self assertElement: aSymbol property: #one hasValue: aSymbol asLowercase! !

!MDDomainTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:46'!
assertElementHasValue: value
	self assert: (self atElement: self element property: #one) = value! !

!MDDomainTest methodsFor: 'proxy access' stamp: 'jf 10/21/2009 16:13'!
atElement: element property: property 
	^ (domain at: element) 
		at: property
		ifAbsent: [ nil ]! !

!MDDomainTest methodsFor: 'proxy access' stamp: 'jf 10/21/2009 16:13'!
atElement: element property: property put: value 
	"This will need to be overriden in tests that use a real image proxy."
	(domain at: element) 
		at: property
		put: value! !

!MDDomainTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:16'!
atProperty: aSymbol
	^ self atElement: self element property: aSymbol! !

!MDDomainTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:17'!
atProperty: aSymbol put: aValue
	self atElement: self element property: aSymbol put: aValue
! !

!MDDomainTest methodsFor: 'configuration' stamp: 'jf 10/21/2009 16:19'!
domainClass
	^ MDFakeDomain! !

!MDDomainTest methodsFor: 'running' stamp: 'jf 10/21/2009 16:39'!
setUp
	environment := MDEnvironment new.
	domain := environment addDomain: self domainClass new! !

MDDomainTest subclass: #MDMergeTest
	instanceVariableNames: 'wc merge local remote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDMergeTest methodsFor: 'running' stamp: 'cwp 9/4/2009 14:19'!
local: localVersion remote: remoteVersion
	local := localVersion.
	environment workspace loadVersion: local.
	remote := remoteVersion.
	merge := MDMerge toInclude: remote in: environment workspace.
! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 14:18'!
testApplyLocal
	self 
		local: (self versionWith: 'local')
		remote: (self versionWith: 'remote').
	merge chooseLocal.
	merge applyTo: environment workspace.
	self assertElementHasValue: 'local'! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 14:17'!
testApplyRemote
	self 
		local: (self versionWith: 'local')
		remote: (self versionWith: 'remote').
	merge chooseRemote.
	merge applyTo: environment workspace.
	self assertElementHasValue: 'remote'! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:05'!
testChooseLocal
	self local: self version remote: self version.
	self assert: merge isConflict.
	merge chooseLocal.
	self assert: merge isLocal.
	self assert: merge resolution == local! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:06'!
testChooseRemote
	self local: self version remote: self version.
	self assert: merge isConflict.
	merge chooseRemote.
	self assert: merge isRemote.
	self assert: merge resolution == remote! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 8/9/2009 01:29'!
testIsConflict
	| version |
	version := self version.
	self local: version remote: version copy.
	self assert: merge isConflict.
	self assert: merge isLocal.
	self deny: merge isRemote.
! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testIsLocal
	remote := self version.
	local := self updateVersion: remote property: #one put: 'alpha2'.
	self local: local remote: remote.
	self assert: merge isLocal.
	self deny: merge isRemote.
	self deny: merge isConflict.! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testIsRemote
	local := self version.
	remote := self updateVersion: local property: #one put: 'alpha2'.
	self local: local remote: remote.
	self assert: merge isRemote.
	self deny: merge isLocal.
	self deny: merge isConflict.
! !

MDDomainTest subclass: #MDSliceOpsTest
	instanceVariableNames: 'repository snapshot workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:26'!
addToBoth: aVersion
	snapshot add: aVersion.
	repository add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToRepository: aVersion
	repository add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToSnapshot: aVersion
	snapshot add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:28'!
prepare
	self prepare: 
		[self addToBoth: (self versionFor: #Alpha with: 'alpha').
		self addToBoth: (self versionFor: #Beta with: 'beta')].
! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
prepare: aBlock
	| repositoryVersions |
	repository := Set new.
	snapshot := Set new.
	aBlock value.
	repositoryVersions := repository.
	repository := MDMemoryRepository new.
	repositoryVersions do: [:ea | repository put: ea].
	snapshot := MDSnapshot withVersions: snapshot
	
	! !

!MDSliceOpsTest methodsFor: 'running' stamp: 'cwp 9/4/2009 16:47'!
setUp
	super setUp.
	workspace := environment workspace! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/16/2005 00:24'!
slice
	^ (MDExplicitSlice named: 'TestSlice')
		addElement: (self element: #Alpha);
		addElement: (self element: #Beta);
		yourself
	! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testAsExplicitSlice
	| original copy |
	original := self slice.
	copy := original asExplicitSlice.
	self assert: (copy isKindOf: MDExplicitSlice).
	self assert: copy elements = original elements! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testIncludeSnapshot
	self prepare.
	
	[ self slice 
		include: snapshot
		from: repository
		in: workspace ] 
		on: MDMergeRequest
		do: [ :ex | ex merges do: [ :ea | ea applyTo: workspace ] ].
	self assertElementHasDefaultValue: #Alpha.
	self assertElementHasDefaultValue: #Beta! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testLoadEqualSnapshot
	self prepare.
	self slice 
		load: snapshot
		from: repository
		to: workspace.
	self assertElementHasDefaultValue: #Alpha.
	self assertElementHasDefaultValue: #Beta! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testLoadLargerSnapshot
	| slice alpha beta |
	self prepare.
	alpha := self element: #Alpha.
	beta := self element: #Beta.
	slice := MDExplicitSlice named: 'TestSlice'.
	slice addElement: alpha.
	slice 
		load: snapshot
		from: repository
		to: workspace.
	self assert: (self 
			atElement: alpha
			property: #one) = 'alpha'.
	self assert: (self 
			atElement: beta
			property: #one) = 'beta'.
	self assert: slice elements size = 1! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testLoadSmallerSnapshot
	self prepare: [ self addToBoth: (self 
				versionFor: #Alpha
				with: 'alpha') ].
	self slice 
		load: snapshot
		from: repository
		to: workspace.
	self assertElementHasDefaultValue: #Alpha.
	self 
		assertElement: #Beta
		property: #one
		hasValue: nil! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testLoadWithDepenencies
	self prepare: 
		[ self addToBoth: (self versionFor: #Alpha).
		self addToBoth: (self versionFor: #Beta).
		self addToBoth: (self 
				versionFor: #'Alpha/Delta'
				with: 'ad') ].
	self slice 
		load: snapshot
		from: repository
		to: workspace.
	self
		assertElementHasDefaultValue: #Alpha;
		assertElementHasDefaultValue: #Beta;
		assertElement: #'Alpha/Delta'
			property: #one
			hasValue: 'ad'! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 9/4/2009 16:47'!
testSaveWithMemo
	| slice versions memo |
	self prepare: [  ].
	slice := self slice.
	memo := self memo.
	snapshot := slice 
		saveFrom: workspace
		to: repository
		memo: memo.
	versions := snapshot getVersionsFrom: repository.
	slice do: 
		[ :element | 
		self assert: (versions anySatisfy: [ :version | version element = element ]) ].
	self deny: (repository get: snapshot hashstamp) isNil.
	self deny: (repository get: memo hashstamp) isNil! !

MDDomainTest subclass: #MDWorkspaceTest
	instanceVariableNames: 'workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDWorkspaceTest methodsFor: 'asserting' stamp: 'jf 9/8/2009 16:25'!
assertConflictIncluding: anElementVersion 
	workspace 
		includeVersion: anElementVersion
		onConflict: [ :a :b | ^ self ].
	self assert: false! !

!MDWorkspaceTest methodsFor: 'asserting' stamp: 'jf 9/8/2009 16:25'!
assertNoConflictIncluding: anElementVersion 
	workspace 
		includeVersion: anElementVersion
		onConflict: 
			[ :a :b | 
			self assert: false.
			^ self ]! !

!MDWorkspaceTest methodsFor: 'running' stamp: 'jf 9/8/2009 16:25'!
setUp
	super setUp.
	workspace := environment workspace! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testImplicitDomainCreation
	| domain |
	domain := workspace domainForElement: (MDClassElement className: #MDBogusA).
	self assert: domain class type = #smalltalk! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 14:20'!
testIncludeAbsentVersion
	| version |
	version := self version.
	version variant properties one: 'bar'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #one) = 'bar'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testIncludeConflictingVersion
	| version newVersion newVersion2 |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	newVersion2 := self 
		updateVersion: version
		property: #source
		put: 'three'.
	workspace loadVersion: newVersion.
	self assertConflictIncluding: newVersion2! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testIncludeNewVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	self assertNoConflictIncluding: newVersion.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testIncludeOldVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	workspace loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testLoad
	| version |
	version := self version.
	version variant properties one: '1'.
	workspace loadVersion: version.
	self assert: (self atProperty: #one) = '1'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testLoadAndSave
	| version |
	version := self version.
	version variant properties one: '1'.
	workspace loadVersion: version.
	self assert: (workspace versionForElement: version element) == version! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testLoadDeleteAndSave
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	domain removeElement: version element.
	newVersion := workspace versionForElement: version element.
	workspace loadVersion: newVersion.
	self deny: (domain includesElement: version element)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testLoadModifyAndSave
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	self assert: (workspace versionForElement: version element) == version.
	self 
		atProperty: #source
		put: 'two'.
	newVersion := workspace versionForElement: version element.
	self deny: newVersion == version.
	self assert: (newVersion succeeds: version)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testLoadModifySaveAndSave
	| version newVersion newVersion2 |
	version := self version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	self assert: (workspace versionForElement: version element) == version.
	self 
		atProperty: #source
		put: 'two'.
	newVersion := workspace versionForElement: version element.
	newVersion2 := workspace versionForElement: version element.
	self assert: newVersion == newVersion2! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testLoadOldVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	workspace loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	workspace loadVersion: version.
	self assert: (self atProperty: #source) = 'one'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testModifyAndIncludeConflictingVersion
	| version newVersion |
	version := self version.
	version variant properties source: 'one'.
	workspace loadVersion: version.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	self 
		atProperty: #source
		put: 'three'.
	self assertConflictIncluding: newVersion! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testResolveConflict
	| version newVersion newVersion2 mergedVersion |
	version := self version.
	version variant properties source: 'one'.
	newVersion := self 
		updateVersion: version
		property: #source
		put: 'two'.
	newVersion2 := self 
		updateVersion: version
		property: #source
		put: 'three'.
	workspace loadVersion: newVersion.
	workspace 
		includeVersion: newVersion2
		onConflict: 
			[ :a :b | 
			self assert: a variant properties source = 'two'.
			b variant ].
	self assert: (self atProperty: #source) = 'three'.
	mergedVersion := workspace versionForElement: version element.
	self assert: mergedVersion variant = newVersion2 variant.
	self assert: (mergedVersion succeeds: newVersion).
	self assert: (mergedVersion succeeds: newVersion2)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testSaveAbsentVersion
	| saved constructed |
	saved := workspace versionForElement: self element.
	constructed := self versionFor: #Alpha.
	self assert: saved ancestry isEmpty.
	self assert: (constructed succeeds: saved)! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 9/8/2009 16:25'!
testSaveFirstVersion
	| version |
	self 
		atElement: self element
		property: #one
		put: 'one'.
	version := workspace versionForElement: self element.
	self assert: version ancestry isEmpty.
	self assert: version variant properties one = 'one'! !

!MDWorkspaceTest methodsFor: 'tests' stamp: 'jf 10/21/2009 16:13'!
testTransaction
	| version |
	version := self version.
	version variant properties one: '1'.
	workspace transaction: 
		[ workspace loadVersion: version.
		self deny: (domain includesElement: version element) ].
	self assert: (self atProperty: #one) = '1'! !

MDTestCase subclass: #MDMemoTest
	instanceVariableNames: 'memo snapshot slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDMemoTest methodsFor: 'accessing' stamp: 'cwp 1/19/2007 22:27'!
parents
	^ Set
		with: (self memo: #a)
		with: (self memo: #b)! !

!MDMemoTest methodsFor: 'accessing' stamp: 'cwp 1/15/2007 22:13'!
properties
	^ MDPropertyDictionary new! !

!MDMemoTest methodsFor: 'running' stamp: 'cwp 5/22/2008 00:10'!
setUp
	memo := MDMemo 
		parents: self parents
		properties: self properties.
	snapshot := self snapshot.
	slice := self slice.
	memo setSnapshot: snapshot slice: slice
! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 8/10/2009 22:05'!
testDescription
	memo 
		instVarNamed: 'hashstamp' 
		put: (MDHashstamp timestamp: (MDTimestamp fromInteger: 886029518)).
	memo properties 
		author: 'Colin Putney <cputney@wireong.ca>';
		comment: 'Snapshot for testing.';
		initials: 'cwp';
		ordinal: 1;
		sliceName: 'Bogus'.
	self assert: memo description = 'timestamp: 28 March 2008 11:18:38 pm
author: ''Colin Putney <cputney@wireong.ca>''

Snapshot for testing.'! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 11/17/2007 01:27'!
testName
	memo properties initials: 'abc'.
	memo properties ordinal: 23.
	self assert: memo name = 'TestSlice-abc.23'! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:36'!
testParents
	self assert: memo parents size = 2.
	self assert: (memo parents allSatisfy: [:ea | ea isKindOf: MDMemo]).
! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:36'!
testProperties
	self assert: (memo properties isKindOf: MDPropertyDictionary)! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:38'!
testSlice
	self assert: (memo matchesSlice: slice)! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 23:01'!
testSliceName
	self assert: (memo sliceName = slice name)! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 22:37'!
testSnapshot
	self assert: (memo hashstamp isKindOf: MDHashstamp).
	self assert: (memo reference isKindOf: MDHashstamp).
	self assert: memo reference = snapshot hashstamp.
	self deny: memo reference = memo hashstamp.
! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortByAuthor
	| other |
	other := memo deepCopy.
	
	memo properties initials: 'abd'.
	memo properties ordinal: 23.
	
	other properties initials: 'abc'.
	other properties ordinal: 23.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortByOrdinal
	| other |
	other := memo deepCopy.
	
	memo properties initials: 'abc'.
	memo properties ordinal: 23.
	
	other properties initials: 'abc'.
	other properties ordinal: 22.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortByOrdinalFirst
	| other |
	other := memo deepCopy.
	
	memo properties initials: 'abc'.
	memo properties ordinal: 23.
	
	other properties initials: 'abd'.
	other properties ordinal: 22.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortWithoutAuthors
	| other |
	other := memo deepCopy.
	memo properties ordinal: 23.
	other properties ordinal: 22.
	self assert: other <= memo! !

!MDMemoTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testSortWithoutOrdinals
	| other |
	other := memo deepCopy.
	memo properties initials: 'abd'.
	other properties initials: 'abc'.
	self assert: other <= memo! !

MDTestCase subclass: #MDSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/4/2005 17:39'!
assertEqualityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after = before]! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 11/8/2009 21:48'!
assertEqualityOf: anObject using: aBlock 
	| other buffer |
	buffer := MDSerializer serialize: anObject.
	other := MDMaterializer materialize: buffer.
	aBlock value: anObject value: other! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/2/2008 11:04'!
assertIdentityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after == before]! !

!MDSerializationTest methodsFor: 'running' stamp: 'cwp 11/8/2009 21:49'!
setUp
	super setUp.
	MDMaterializer initializeTypes! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:13'!
testArray
	self assertEqualityOf: #(1 2 3)! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 14:02'!
testBytesObject
	self assertEqualityOf: #(1 2 3) asByteArray! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:45'!
testClass
	self assertIdentityOf: self class! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:20'!
testClassCommentElement
	self assertEqualityOf: (MDClassCommentElement className: #MDBogusA)! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:20'!
testClassElement
	self assertEqualityOf: (MDClassElement className: #MDBogusA)! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:22'!
testClassInstVarElement
	self assertEqualityOf: (MDClassInstVarElement className: #MDBogusA name: 'beth')! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/9/2005 21:45'!
testClassMethodElement
	self assertEqualityOf: (MDMethodElement 
							className: #MDBogusA 
							selector: #one 
							classIsMeta: true)! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:21'!
testClassVarElement
	self assertEqualityOf: (MDClassVarElement className: #MDBogusA name: 'Alpha')! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:29'!
testDictionary
	| dict |
	dict := Dictionary new
			at: #a put: 1;
			at: #b put: 2;
			yourself.
	self assertEqualityOf: dict! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 17:21'!
testElementDefinition
	self assertEqualityOf: self definition! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 17:04'!
testElementRemoval
	self assertEqualityOf: self removal.! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 15:35'!
testFakeElement
	self assertEqualityOf: self element! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:04'!
testFalse
	self assertIdentityOf: false ! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 8/8/2009 17:30'!
testHashstamp
	self assertEqualityOf: MDHashstamp new! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:21'!
testInstVarElement
	self assertEqualityOf: (MDInstVarElement className: #MDBogusA name: 'one')! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 5/22/2008 00:10'!
testLongString
	| string |
	string := String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 1/19/2007 22:27'!
testMemo
	self assertEqualityOf: self memo ! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 3/7/2005 16:23'!
testMethodElement
	self assertEqualityOf: (MDMethodElement className: #MDBogusA selector: #one)! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 6/23/2008 13:22'!
testMultiString
	| ws |
	ws := MDPlatform current wideString.
	ws ifNotNil: [self assertEqualityOf: ws]! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:26'!
testNegativeLargeInteger
	self assertEqualityOf: SmallInteger minVal - 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 02:03'!
testNegativeOneByteInteger
	self assertEqualityOf: -3! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:20'!
testNegativeTwoByteInteger
	self assertEqualityOf: -300! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:05'!
testNil
	self assertIdentityOf: nil! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 16:27'!
testOneByteInteger
	self assertEqualityOf: 7! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 14:06'!
testPointersObject
	self assertEqualityOf: MDPlatform current variablePointersObject ! !

!MDSerializationTest methodsFor: 'tests - smalltalk' stamp: 'cwp 4/28/2008 22:04'!
testPoolImportElement
	self assertEqualityOf: (MDPoolImportElement 
			className: #MDBogusA
			name: #MDBogusPoolA)! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 10:26'!
testPositiveLargeInteger
	self assertEqualityOf: SmallInteger maxVal + 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 5/22/2008 00:10'!
testPropertyDictionary
	| properties |
	properties := MDPropertyDictionary new.
	properties
		first: 1;
		second: 'two'.
	self assertEqualityOf: properties! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:25'!
testSet
	self assertEqualityOf: #(1 2 3) asSet! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'jf 9/6/2009 12:56'!
testSliceElement
	self assertEqualityOf: (MDSliceElement 
							for: (MDExplicitSlice named: 'TestSlice'))! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/10/2005 23:41'!
testSnapshot
	self assertEqualityOf: self snapshot ! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/4/2005 17:22'!
testString
	self assertEqualityOf: 'abc'.! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 4/15/2008 21:40'!
testStringWithAccent
	self assertEqualityOf: 'bc'.! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 17:15'!
testSymbol
	self assertEqualityOf: #one using: [:before :after | self assert: before == after]! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 6/5/2008 22:29'!
testThreeByteInteger
	self assertEqualityOf: (2 raisedTo: 16) + 1! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 11/8/2009 21:48'!
testTimestamp
	| ts buffer |
	ts := MDTimestamp now.
	buffer := MDSerializer serialize: ts.
	self assert: buffer size = 5.
	self assert: (MDMaterializer materialize: buffer) = ts! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/2/2008 11:04'!
testTrue
	self assertIdentityOf: true! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 3/7/2005 16:44'!
testTwoByteInteger
	self assertEqualityOf: 355! !

!MDSerializationTest methodsFor: 'tests - core' stamp: 'cwp 10/16/2005 14:42'!
testVersion
	self 
		assertEqualityOf: self version 
		using: [:before :after |
				self assert: before variant = after variant.
				self assert: before hashstamp = after hashstamp.
				self assert: before ancestry = after ancestry]! !

!MDTestCase class methodsFor: 'testing' stamp: 'cwp 3/2/2005 22:35'!
isAbstract
	^ self name = #MDTestCase! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/24/2008 14:41'!
builder
	^ MDTestBuilder new! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:43'!
definition
	^ MDDefinitionVariant forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
definition: aSymbol
	| definition |
	definition := MDDefinitionVariant forElement: (self element: aSymbol).
	definition properties at: #one put: 1.
	^ definition! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element
	^ self element: #Alpha! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element: aSymbol
	^ MDFakeElement named: aSymbol! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
elements
	^ Set
		with: (MDFakeElement named: #Alpha)
		with: (MDFakeElement named: #Beta)! !

!MDTestCase methodsFor: 'asserting' stamp: 'cwp 3/2/2005 22:51'!
fail
	self signalFailure: 'Assertion failed'! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:26'!
memo
	^ self memo: #abc! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 1/19/2007 22:28'!
memo: aSymbol
	^ MDMemo
		snapshot: self snapshot
		slice: self slice
		parents: Set new
		properties: (MDPropertyDictionary new id: aSymbol; yourself)! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal
	^ MDRemovalVariant forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 13:45'!
removal: aSymbol
	^ MDRemovalVariant forElement: (self element: aSymbol)! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 1/19/2007 23:12'!
slice
	^ MDExplicitSlice named: 'TestSlice'.! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
sliceVersion
	| element variant slice |
	slice := self slice.
	element := MDSliceElement forSlice: slice.
	variant := MDDefinitionVariant forElement: element.
	slice properties keysAndValuesDo: [:k :v | variant properties at: k put: v].
	^ MDElementVersion variant: variant! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:09'!
snapshot
	^ self snapshot: [:versions | ].
! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/24/2008 13:21'!
snapshot: aBlock
	| versions |
	versions := Set new.	
	versions 
		add: (self versionFor: #Alpha with: 'alpha');
		add: (self versionFor: #Beta with: 'beta')	.
	aBlock value: versions.
	^ MDSnapshot withVersions: versions! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:12'!
updateVersion: anElementVersion property: aSymbol put: anObject 
	| newVariant |
	newVariant := anElementVersion variant copy.
	newVariant properties at: aSymbol put: anObject.
	^MDElementVersion 
		variant: newVariant
		ancestry: anElementVersion fullAncestry! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 10/16/2005 14:39'!
version
	^ MDElementVersion variant: self definition! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/25/2005 22:55'!
versionFor: elementName
	^ self versionFor: elementName with: elementName asLowercase! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
versionFor: elementName with: value
	| element snapshot |
	element := MDFakeElement named: elementName.
	snapshot := MDDefinitionVariant forElement: element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 5/22/2008 00:10'!
versionWith: value
	| snapshot |
	snapshot := MDDefinitionVariant forElement: self element.
	snapshot properties at: #one put: value.
	^ MDElementVersion variant: snapshot! !

TestCase subclass: #MDTimestampPrinterTest
	instanceVariableNames: 'ts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
assert: format prints: expected
	| actual |
	actual := ts printFormat: format.
	self assert: expected = actual! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
testNativePrintOn
	ts := MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 3
			minute: 2
			second: 1.
	self assert: '%e %B %Y %i:%M:%S %p' prints: '4 May 2006 3:02:01 am'! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
testSqueakMethodStampAm
	ts := MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 1
			minute: 2
			second: 1.
	self assert: '%l/%e/%Y %H:%M' prints: '5/4/2006 01:02'! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:10'!
testSqueakMethodStampPm
	ts := MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 15
			minute: 2
			second: 1.
	self assert: '%l/%e/%Y %H:%M' prints: '5/4/2006 15:02'! !

TestCase subclass: #MDTimestampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Core'!

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
intWithBytes: anArray
	| int |
	int := 0.
	1 to: 4 do: [:i | int := (int bitShift: 8) + (anArray at: i)].
	^ int! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:10'!
recompose: units
	| int |
	int := MDTimestamp compose: units.
	^ (MDTimestamp fromInteger: int) decompose! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testAsInteger
	| int ts |
	int := self intWithBytes: #(1 2 3 4).
	ts := MDTimestamp fromInteger: int.
	self assert: ts asInteger = int.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testByteOrder
	| ts |
	ts := self tsWithBytes: #(1 2 3 4).
	self assert: (ts byteAt: 1) = 1.
	self assert: (ts byteAt: 2) = 2.
	self assert: (ts byteAt: 3) = 3.
	self assert: (ts byteAt: 4) = 4.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testComposition1
	| units |
	units := #(1 2 3 4 5 6 7).
	self assert: (self recompose: units) = units! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testComposition2
	| before after |
	before := #(7 3 5 4 3 2 1).
	after := self recompose: before.
	self assert: before = after! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/16/2005 16:50'!
testDays
	self assert: (self ts: #(2001 02 23 00 00 00)) day = 23.
	self assert: (self ts: #(2001 02 23 00 00 01)) day = 23.
	self assert: (self ts: #(2001 02 23 23 59 59)) day = 23.
	self assert: (self ts: #(2005 02 23 12 00 00)) day = 23.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 01:38'!
testEndOfEpoch
	self 
	should: [MDTimestamp fromInteger: MDTimestamp last asInteger + 1]
	raise: Error! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testEpoch
	| ts |
	ts := MDTimestamp epoch.
	self assert: ts byteSize <= 4.
	self assert: ts asInteger = 0! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testEquality
	| left right |
	left := MDTimestamp now.
	right := left copy.
	self deny: left == right.
	self assert: left = right.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour01
	self assert: (self ts: #(2001 02 23 00 00 00)) hour = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour02
	self assert: (self ts: #(2001 02 23 01 00 01)) hour = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour03
	self assert: (self ts: #(2001 02 23 23 59 59)) hour = 23.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:20'!
testHour04
	self assert: (self ts: #(2005 04 07 01 30 00)) hour = 1.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 23:02'!
testLeapYear
	| ts |
	ts := self ts: #(2004 02 29 01 00 00).
	self assert: ts day = 29.
	self assert: ts month = 2! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude01
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 3 5).
	self assert: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude02
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 3 4).
	self deny: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude03
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 3 3).
	self deny: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMagnitude04
	| a b |
	a := self tsWithBytes: #(1 2 3 4).
	b := self tsWithBytes: #(1 2 4 4).
	self assert: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute01
	self assert: (self ts: #(2001 02 23 00 00 00)) minute = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute02
	self assert: (self ts: #(2001 02 23 01 01 01)) minute = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute03
	self assert: (self ts: #(2001 02 23 23 59 59)) minute = 59.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testMonths
	| base increment ts |
	base :=  24969600. 			"Value of Dec 15, the year of the epoch"
	increment := 86400 * 30.		"Number of seconds in 30 days"
	
	"Start at Jan 15, and add 30 days at a time, to test each month."
	1 to: 12 do: 
		[:i | 
		ts := MDTimestamp fromInteger: i * increment + base.
		self assert: ts month = i]! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testNow
	| ts |
	ts := MDTimestamp now.
	self assert: ts size <= 4.
	self assert: ts asInteger positive! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting1
	| ts |
	ts := self ts: #(2000 03 01 00 00 00).
	self assert: ts printString = '1 March 2000 12:00:00 am'.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting2
	| ts |
	ts := self ts: #(2005 04 07 23 28 31).
	self assert: ts printString = '7 April 2005 11:28:31 pm'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting3
	| ts |
	ts := self ts: #(2005 04 07 03 28 31).
	self assert: ts printString = '7 April 2005 3:28:31 am'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:10'!
testRange
	| begin end |
	begin := MDTimestamp epoch.
	end := MDTimestamp last.
	self assert: MDTimestamp range = (end asInteger - begin asInteger)! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond01
	self assert: (self ts: #(2001 02 23 00 00 00)) second = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond02
	self assert: (self ts: #(2001 02 23 01 01 01)) second = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond03
	self assert: (self ts: #(2001 02 23 23 59 59)) second = 59.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear01
	self assert: (self ts: #(1984 02 28 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear02
	self assert: (self ts: #(1984 02 29 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear03
	self assert: (self ts: #(1984 03 01 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear04
	self assert: (self ts: #(2001 02 23 00 01 00)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear05
	self assert: (self ts: #(2001 02 28 23 59 59)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear06
	self assert: (self ts: #(2001 03 01 00 00 00)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear07
	self assert: (self ts: #(2001 03 01 00 00 01)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear08
	self assert: (self ts: #(2003 02 23 00 01 00)) year = 2003.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:30'!
testYear09
	self assert: (self ts: #(2003 02 23 00 01 00)) year = 2003.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:38'!
testYear10
	self assert: (self ts: #(2004 02 23 00 01 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:33'!
testYear11
	self assert: (self ts: #(2004 02 29 00 01 00)) year = 2004.
	! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:34'!
testYear12
	self assert: (self ts: #(2004 04 29 00 01 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:34'!
testYear13
	self assert: (self ts: #(2005 02 23 00 01 00)) year = 2005.
	! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 20:30'!
testYear14
	self assert: (self ts: #(2004 01 07 09 11 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 6/18/2005 16:04'!
ts: anArray
	| parts |
	parts := Array new: 6.
	parts atAllPut: 0.
	anArray withIndexDo: [:ea :i | parts at: i put: ea].
	^ MDTimestamp
		year: (parts at: 1)
		month: (parts at: 2)
		day: (parts at: 3)
		hour: (parts at: 4)
		minute: (parts at: 5)
		second: (parts at: 6)! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 9/11/2005 18:25'!
tsWithBytes: anArray
	^ MDTimestamp fromInteger: (self intWithBytes: anArray)! !
